﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ThunderDashboard
{
	public partial class Form2015 : System.Windows.Forms.Form
	{
		public Form2015()
		{
			InitializeComponent();
		}

		// called when the window is first shown
		private void Form2015_Shown(object sender, EventArgs e)
		{
			// put window in upper-left corner of screen
			Location = new Point(0, 0);

			// connect to network table
			string teamNumber = "1511";
			string robotIpAddress = "roboRIO-" + teamNumber + "-FRC";
            DashboardNetworkTable.Start(robotIpAddress, NetworkTableDelegate);

			// connect to scanner
			//cameraControl.Start(robotIpAddress, 1180);
		}

		// called when the window is being closed
		private void Form2015_FormClosed(object sender, FormClosedEventArgs e)
		{
			DashboardNetworkTable.Stop();
			cameraControl.Stop();
		}

		// called when a entry in the table changes
		private void NetworkTableDelegate(string key, string value)
		{
            // validate
            if (value == null)
            {
                return;
            }

			switch (key)
			{
				default:		// nothing we care about
					break;

                case "thunderdashboard_breacher":
                    rightGripperBar.Value = value;
                    break;
            }
        }

    }
}
