﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ThunderDashboard
{
	public partial class FormMain
	{
		// Server button was pressed
		public void buttonServer_Click(object sender, EventArgs e)
		{
            DashboardNetworkTable.Start("", null, false);
    		buttonClient.Enabled = false;
		}

		// Client button was pressed
		private void buttonClient_Click(object sender, EventArgs e)
		{
            DashboardNetworkTable.Start("127.0.0.1", NetworkTableDelegate);
			buttonServer.Enabled = false;
			buttonClient.Enabled = false;
		}

		// add a string to the network table
		private void buttonStringAdd_Click(object sender, EventArgs e)
		{
			if (!DashboardNetworkTable.PutString(textBoxStringName.Text, textBoxStringValue.Text))
			{
				MessageBox.Show(DashboardNetworkTable.LastError(), "ERROR");
			}
		}

		// get a string to the network table
		private void buttonStringGet_Click(object sender, EventArgs e)
		{
			string value = "";
			if (!DashboardNetworkTable.GetString(textBoxStringName.Text, ref value, "empty"))
			{
				MessageBox.Show(DashboardNetworkTable.LastError(), "ERROR");
			}
			textBoxStringValue.Text = value;
		}

        private void buttonNumberAdd_Click(object sender, EventArgs e)
        {
            double value;
            try
            {
                value = Convert.ToDouble(textBoxNumberValue.Text);
            }
            catch
            {
                MessageBox.Show("Value is not a number", "ERROR");
                return;
            }
            if (!DashboardNetworkTable.PutNumber(textBoxNumberName.Text, value))
            {
                MessageBox.Show(DashboardNetworkTable.LastError(), "ERROR");
            }
        }

        private void buttonNumberGet_Click(object sender, EventArgs e)
        {
            double value = 0;
            if (!DashboardNetworkTable.GetNumber(textBoxNumberName.Text, ref value, 0))
            {
                MessageBox.Show(DashboardNetworkTable.LastError(), "ERROR");
            }
            textBoxNumberValue.Text = value.ToString();
        }
   
        // called when table is changed
        private void NetworkTableDelegateDebug(string key, string value)
		{
			if (key == textBoxStringName.Text)
			{
				textBoxStringValue.Text = value;
			}
		}
	}
}
